

--
-- adder
--

     entity adder is
      -- i0, i1 and the carry-in ci are inputs of the adder.
       -- s is the sum output, co is the carry-out.
       port (i0, i1 : in bit; ci : in bit;             s : out bit; co : out bit);
     end adder;
     
     architecture rtl of adder is
     begin
        --  This full-adder architecture contains two concurrent assignment.
        --  Compute the sum.
        s <= i0 xor i1 xor ci;
        --  Compute the carry.
        co <= (i0 and i1) or (i0 and ci) or (i1 and ci);
     end rtl;

     entity led_dhr is
       port (  led1 : in bit; led2 : in bit;       led_out  : out bit );
     end led_dhr;
     




--
-- led_dhr - some random logic
--

     architecture rtl of led_dhr is
     begin
        --  This random logic is a try.
--        led_out <= led1 xor led2 ;
        led_out <= led1 or led2 ;
     end rtl;

    
--
-- VHDL FlipFlop, dff.vhd
-- library ieee;
-- use ieee.std_logic_1164.ALL;



--
-- D-type flop flop
--
    
--  Hello world program.     
use std.textio.all; --  Imports the standard textio package.

ENTITY dff is
     port(clk  : in  bit;
          din  : in  bit;
          dout : out bit);
 end dff;

ARCHITECTURE rtl of dff is
 begin
     p1:process(clk)
         variable l : line;
         begin
             if  CLK'event and CLK='1' then 
                 dout <= din;
                 write (l, String'("dff - CLK'event and CLK='1' "));
                 writeline (output, l);
             end if;
     end process;
 end rtl;



--
--  Hello world program.
--


     --  Hello world program.
     use std.textio.all; --  Imports the standard textio package.
     --  Defines a design entity, without any ports.
     entity hello_world is
     end hello_world;
     
     architecture behaviour of hello_world is
     begin
        process
           variable l : line;
        begin
           write (l, String'("Hello world! Hello doug"));
           writeline (output, l);
           write (l, String'("xxxxxxxxxxxxxxxxxxxxxxx"));
           writeline (output, l);
           wait;
        end process;
     end behaviour;


