--
-- doug_tb.vhdl
--
--
-- modified Testbench from webpage documentation
--
--

     --  A testbench has no ports.
     entity doug_tb is
     end doug_tb;

     architecture behav of doug_tb is


--  Declaration of the components that will be instantiated.

	component doug
		   port (i0, i1 : in bit;  clk : in bit ; out1 , out2: out bit ) ;
        end component;

	component doug_ip
	       port (i0, i1 : in bit;  clk : in bit ; out1 , out2: out bit ) ;
        end component;

	component doug_middle
	       port (i0, i1 : in bit;  clk : in bit ; out1 , out2: out bit ) ;
        end component;

	component doug_op
	       port (i0, i1 : in bit;  clk : in bit ; out1 , out2: out bit ) ;
        end component;



	component doug_board
		   port (i0, i1 : in bit;  clk : in bit ; out1 , out2: out bit ) ;
        end component;


        --  Specifies which entity is bound with the component.
        for doug_0: doug use entity work.doug;
        for doug_ip_0: 	   doug_ip     use entity work.doug_ip;
        for doug_middle_0: doug_middle use entity work.doug_middle;
        for doug_op_0: 	   doug_op     use entity work.doug_op;


		for doug_board_0:  doug_board  use entity work.doug_board;


--
-- named interconnect wires.
--

     signal wire_i0, wire_i1, wire_ci, wire_out , wire_out2 , wire_out3 , wire_outa ,wire_outb ,wire_outc ,
			wire_ip, wire_ip_middle , wire_middle_op , wire_op     : bit;

     begin

		--  Component instantiation.

 --       wire_ip  <= wire_ci;


 --   ----[doug_ip_0]----[doug_middle_0]----[doug_op_0]----

        doug_0: doug port map (
		i0 => wire_ip,
		i1 => wire_i1,
		clk => wire_ci,
		out1 => wire_out,
		out2 => wire_out2 );


        doug_ip_0: doug_ip port map (
		i0 => wire_ip,
		i1 => wire_i1,
		clk => wire_ci,
		out1 => wire_outa,
		out2 => wire_ip_middle );


        doug_middle_0: doug_middle port map (
		i0 => wire_ip_middle,
		i1 => wire_i1,
		clk => wire_ci,
		out1 => wire_outb,
		out2 => wire_middle_op );

       doug_op_0: doug_op port map (
		i0 => wire_middle_op,
		i1 => wire_i1,
		clk => wire_ci,
		out1 => wire_outc,
		out2 => wire_op );


        doug_board_0: doug_board port map (
		i0 => wire_ip,
		i1 => wire_i1,
		clk => wire_ci,
		out1 => wire_out,
		out2 => wire_out3 );


	    -- connect pin  to signal

        --  This process does the real job.
        process
           type pattern_type is record
              --  The inputs of the adder.
              i0, i1, ci : bit;
              --  The expected outputs of the adder.
              s, co : bit;
           end record;
           --  The patterns to apply.
           type pattern_array is array (natural range <>) of pattern_type;
           constant patterns : pattern_array :=

             (--i0, i1,  ci,   s  , co
			  ('0', '0', '0',  '0', '0'),
              ('0', '0', '1',  '1', '0'),
              ('0', '1', '0',  '1', '0'),

--              ('0', '1', '0',  '1', '1'), --  error

              ('0', '1', '1',  '0', '1'),
              ('1', '0', '0',  '1', '0'),
              ('1', '0', '1',  '0', '1'),
              ('1', '1', '0',  '0', '1'),
              ('1', '1', '1',  '1', '1'));
        begin
           --  Check each pattern.

           for i in patterns'range loop
              --  Set the inputs.
              wire_i0 <= patterns(i).i0;
              wire_i1 <= patterns(i).i1;
              wire_ci <= patterns(i).ci;
              wire_ip <= patterns(i).ci;
              --  Wait for the results.
              wait for 10 ns;
              --  Check the outputs.
--              assert wire_s = patterns(i).s
--                 report "bad sum value" severity error;
--              assert wire_co = patterns(i).co
--                 report "bad carray out value" severity error;
           end loop;
           assert false report "end of test" severity note;
           --  Wait forever; this will finish the simulation.
           wait;
        end process;
     end behav;

